type t = Dom.cssStyleDeclaration;
type cssRule; /* TODO: Move to Webapi__Dom */

[@get] external cssText: t => string;
[@set] external setCssText: (t, string) => unit = "cssText";
[@get] external length: t => int;
[@get] external parentRule: t => cssRule;

[@send] external getPropertyPriority: (t, string) => string;
[@send] external getPropertyValue: (t, string) => string;
[@send] external item: (t, int) => string;
[@send] external removeProperty: (t, string) => string;
[@send] external setProperty: (t, string, string, string) => unit;
[@send] external setPropertyValue: (t, string, string) => unit;

/* CSS2Properties */
[@get] external azimuth: t => string;
[@get] external background: t => string;
[@get] external backgroundAttachment: t => string;
[@get] external backgroundColor: t => string;
[@get] external backgroundImage: t => string;
[@get] external backgroundPosition: t => string;
[@get] external backgroundRepeat: t => string;
[@get] external border: t => string;
[@get] external borderCollapse: t => string;
[@get] external borderColor: t => string;
[@get] external borderSpacing: t => string;
[@get] external borderStyle: t => string;
[@get] external borderTop: t => string;
[@get] external borderRight: t => string;
[@get] external borderBottom: t => string;
[@get] external borderLeft: t => string;
[@get] external borderTopColor: t => string;
[@get] external borderRightColor: t => string;
[@get] external borderBottomColor: t => string;
[@get] external borderLeftColor: t => string;
[@get] external borderTopStyle: t => string;
[@get] external borderRightStyle: t => string;
[@get] external borderBottomStyle: t => string;
[@get] external borderLeftStyle: t => string;
[@get] external borderTopWidth: t => string;
[@get] external borderRightWidth: t => string;
[@get] external borderBottomWidth: t => string;
[@get] external borderLeftWidth: t => string;
[@get] external borderWidth: t => string;
[@get] external bottom: t => string;
[@get] external captionSide: t => string;
[@get] external clear: t => string;
[@get] external clip: t => string;
[@get] external color: t => string;
[@get] external content: t => string;
[@get] external counterIncrement: t => string;
[@get] external counterReset: t => string;
[@get] external cue: t => string;
[@get] external cueAfter: t => string;
[@get] external cueBefore: t => string;
[@get] external cursor: t => string;
[@get] external direction: t => string;
[@get] external display: t => string;
[@get] external elevation: t => string;
[@get] external emptyCells: t => string;
[@get] external cssFloat: t => string;
[@get] external font: t => string;
[@get] external fontFamily: t => string;
[@get] external fontSize: t => string;
[@get] external fontSizeAdjust: t => string;
[@get] external fontStretch: t => string;
[@get] external fontStyle: t => string;
[@get] external fontVariant: t => string;
[@get] external fontWeight: t => string;
[@get] external height: t => string;
[@get] external left: t => string;
[@get] external letterSpacing: t => string;
[@get] external lineHeight: t => string;
[@get] external listStyle: t => string;
[@get] external listStyleImage: t => string;
[@get] external listStylePosition: t => string;
[@get] external listStyleType: t => string;
[@get] external margin: t => string;
[@get] external marginTop: t => string;
[@get] external marginRight: t => string;
[@get] external marginBottom: t => string;
[@get] external marginLeft: t => string;
[@get] external markerOffset: t => string;
[@get] external marks: t => string;
[@get] external maxHeight: t => string;
[@get] external maxWidth: t => string;
[@get] external minHeight: t => string;
[@get] external minWidth: t => string;
[@get] external orphans: t => string;
[@get] external outline: t => string;
[@get] external outlineColor: t => string;
[@get] external outlineStyle: t => string;
[@get] external outlineWidth: t => string;
[@get] external overflow: t => string;
[@get] external padding: t => string;
[@get] external paddingTop: t => string;
[@get] external paddingRight: t => string;
[@get] external paddingBottom: t => string;
[@get] external paddingLeft: t => string;
[@get] external page: t => string;
[@get] external pageBreakAfter: t => string;
[@get] external pageBreakBefore: t => string;
[@get] external pageBreakInside: t => string;
[@get] external pause: t => string;
[@get] external pauseAfter: t => string;
[@get] external pauseBefore: t => string;
[@get] external pitch: t => string;
[@get] external pitchRange: t => string;
[@get] external playDuring: t => string;
[@get] external position: t => string;
[@get] external quotes: t => string;
[@get] external richness: t => string;
[@get] external right: t => string;
[@get] external size: t => string;
[@get] external speak: t => string;
[@get] external speakHeader: t => string;
[@get] external speakNumeral: t => string;
[@get] external speakPunctuation: t => string;
[@get] external speechRate: t => string;
[@get] external stress: t => string;
[@get] external tableLayout: t => string;
[@get] external textAlign: t => string;
[@get] external textDecoration: t => string;
[@get] external textIndent: t => string;
[@get] external textShadow: t => string;
[@get] external textTransform: t => string;
[@get] external top: t => string;
[@get] external unicodeBidi: t => string;
[@get] external verticalAlign: t => string;
[@get] external visibility: t => string;
[@get] external voiceFamily: t => string;
[@get] external volume: t => string;
[@get] external whiteSpace: t => string;
[@get] external widows: t => string;
[@get] external width: t => string;
[@get] external wordSpacing: t => string;
[@get] external zIndex: t => string;
